<?php

namespace Drupal\easy_entity_field\Entity;

use Drupal\Core\Config\Entity\ConfigEntityInterface;

/**
 * Provides an interface for defining Easy entity field entities.
 */
interface EasyEntityFieldInterface extends ConfigEntityInterface {

  public function getName();

  public function getFieldType();

  public function getLabel();

  public function setLabel($label);

  public function getDescription();

  public function setDescription($description);

  public function isRequired();

  public function setRequired($required);

  public function getFieldSettings();

  public function getStorageSettings();

  public function getFieldSetting($setting_name);

  public function getStorageSetting($setting_name);

  public function setFieldSetting($setting_name, $value);

  public function setStorageSetting($setting_name, $value);

  public function setFieldSettings(array $settings);

  public function setStorageSettings(array $settings);

  public function getDefaultValue();

  public function setDefaultValue(array $values);

  public function getFieldStorageDefinition();

  public function getDisplay($display_name);

  public function hasData();

  public function setTargetEntityTypeId($entity_type_id);

  public function getTargetEntityTypeId();

  public function getTargetEntityType();

  public function isTargetEntityType();

  public function getRouteParameter($parameter);

  public function getBaseFieldDefinition();

  public function buildBaseFieldDefinitions();

}
