<?php

namespace Drupal\easy_entity_field\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Drupal\Core\Entity\EntityTypeEventSubscriberTrait;
use Drupal\Core\Entity\EntityTypeInterface;

/**
 * Easy entity base field event subscriber.
 */
class EasyEntityFieldSubscriber implements EventSubscriberInterface {

  use EntityTypeEventSubscriberTrait;

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    return static::getEntityTypeEvents();
  }

  public function onEntityTypeDelete(EntityTypeInterface $entity_type) {
    $easy_entity_fields = \Drupal::entityTypeManager()->getStorage('easy_entity_field')->loadMultiple();
    $settings = \Drupal::configFactory()->listAll('easy_entity_field.settings.');
    $setting_id = 'easy_entity_field.settings.' . $entity_type->id();
    foreach ($settings as $setting) {
      if ($setting == $setting_id) {
        \Drupal::configFactory()->getEditable($setting_id)->delete();
      }
    }

    /**
     * @var \Drupal\easy_entity_field\Entity\EasyEntityFieldInterface $easy_entity_field
     */
    foreach ($easy_entity_fields as $easy_entity_field) {
      if ($easy_entity_field->getTargetEntityTypeId() == $entity_type->id()) {
        $easy_entity_field->delete();
      }
    }
  }

}
